Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jboss.cache.loader
Class SharedStoreCacheLoader

    java.lang.Object
      org.jboss.cache.AbstractTreeCacheListener
          org.jboss.cache.loader.SharedStoreCacheLoader

All Implemented Interfaces:
  ExtendedTreeCacheListener, CacheLoader, TreeCacheListener, org.jboss.system.Service

    public class SharedStoreCacheLoader

extends AbstractTreeCacheListener
implements CacheLoader

CacheLoader proxy used only when multiple CacheLoaders in a cluster access the same underlying store (e.g. a shared filesystem, or DB). SharedStoreCacheLoader is a simply facade to a real CacheLoader implementation. It always delegates reads to the real CacheLoader. Writes are forwarded only if this SharedStoreCacheLoader is currently the cordinator. This avoid having all CacheLoaders in a cluster writing the same data to the same underlying store. Although not incorrect (e.g. a DB will just discard additional INSERTs for the same key, and throw an exception), this will avoid a lot of redundant work.
Whenever the current coordinator dies (or leaves), the second in line will take over. That SharedStoreCacheLoader will then pass writes through to its underlying CacheLoader.

Version:
  $Id: SharedStoreCacheLoader.java,v 1.6 2006/04/08 20:30:08 genman Exp $
Author:
  Bela Ban

Constructor Summary
`SharedStoreCacheLoader(CacheLoader loader, org.jgroups.Address local_addr, boolean coordinator)`

Method Summary
`void` | `cacheStarted(TreeCache cache)` Called when the cache is started.
`void` | `cacheStopped(TreeCache cache)` Called when the cache is stopped.
`void` | `commit(java.lang.Object tx)` Commits the transaction.
`void` | `create()`
`void` | `destroy()`
`boolean` | `exists(Fqn name)` Returns true if the CacheLoader has a node with a `Fqn`.
`java.util.Map` | `get(Fqn name)` Returns all keys and values from the persistent store, given a fully qualified name.
`java.util.Set` | `getChildrenNames(Fqn fqn)` Returns a set of children node names as Strings.
`byte[]` | `loadEntireState()` Fetches the entire state for this cache from secondary storage (disk, DB) and returns it as a byte buffer.
`void` | `nodeCreated(Fqn fqn)` Called when a node is created
`void` | `nodeEvicted(Fqn fqn)` Called when a node is evicted (not the same as remove()).
`void` | `nodeLoaded(Fqn fqn)` Called when a node is loaded into memory via the CacheLoader.
`void` | `nodeModified(Fqn fqn)` Called when a node is modified, e.g., one (key, value) pair in the internal map storage has been modified.
`void` | `nodeRemoved(Fqn fqn)` Called when a node is removed.
`void` | `nodeVisited(Fqn fqn)` Called when a node is visisted, i.e., get().
`void` | `prepare(java.lang.Object tx, java.util.List modifications, boolean one_phase)` Prepares a list of modifications.
`void` | `put(Fqn name, java.util.Map attributes)` Puts all entries of the map into the existing map of the given node, overwriting existing keys, but not clearing the existing map before insertion.
`java.lang.Object` | `put(Fqn name, java.lang.Object key, java.lang.Object value)` Puts a key and value into the attribute map of a given node.
`void` | `put(java.util.List modifications)` Applies all modifications to the backend store.
`void` | `remove(Fqn name)` Removes the given node and all its subnodes.
`java.lang.Object` | `remove(Fqn name, java.lang.Object key)` Removes the given key and value from the attributes of the given node.
`void` | `removeData(Fqn name)` Removes all attributes from a given node, but doesn't delete the node itself or any subnodes.
`void` | `rollback(java.lang.Object tx)` Rolls the transaction back.
`void` | `setCache(TreeCache c)` Sets the `TreeCache` that is maintaining this CacheLoader.
`void` | `setConfig(java.util.Properties props)` Sets the configuration.
`void` | `start()`
`void` | `stop()`
`void` | `storeEntireState(byte[] state)` Stores the given state in secondary storage.
`void` | `viewChange(org.jgroups.View new_view)`

Methods inherited from class org.jboss.cache.AbstractTreeCacheListener
`nodeActivate, nodeEvict, nodeModify, nodePassivate, nodeRemove`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SharedStoreCacheLoader

    public SharedStoreCacheLoader(CacheLoader loader,
                                  org.jgroups.Address local_addr,
                                  boolean coordinator)

Method Detail

### nodeCreated

    public void nodeCreated(Fqn fqn)

  Description copied from interface: `TreeCacheListener`
  Called when a node is created

  Specified by:
    `nodeCreated` in interface `TreeCacheListener`
  Overrides:
    `nodeCreated` in class `AbstractTreeCacheListener`

### nodeRemoved

    public void nodeRemoved(Fqn fqn)

  Description copied from interface: `TreeCacheListener`
  Called when a node is removed.

  Specified by:
    `nodeRemoved` in interface `TreeCacheListener`
  Overrides:
    `nodeRemoved` in class `AbstractTreeCacheListener`

### nodeLoaded

    public void nodeLoaded(Fqn fqn)

  Description copied from interface: `TreeCacheListener`
  Called when a node is loaded into memory via the CacheLoader. This is not the same as `TreeCacheListener.nodeCreated(Fqn)`.

  Specified by:
    `nodeLoaded` in interface `TreeCacheListener`
  Overrides:
    `nodeLoaded` in class `AbstractTreeCacheListener`

### nodeEvicted

    public void nodeEvicted(Fqn fqn)

  Description copied from interface: `TreeCacheListener`
  Called when a node is evicted (not the same as remove()).

  Specified by:
    `nodeEvicted` in interface `TreeCacheListener`
  Overrides:
    `nodeEvicted` in class `AbstractTreeCacheListener`

### nodeModified

    public void nodeModified(Fqn fqn)

  Description copied from interface: `TreeCacheListener`
  Called when a node is modified, e.g., one (key, value) pair in the internal map storage has been modified.

  Specified by:
    `nodeModified` in interface `TreeCacheListener`
  Overrides:
    `nodeModified` in class `AbstractTreeCacheListener`

### nodeVisited

    public void nodeVisited(Fqn fqn)

  Description copied from interface: `TreeCacheListener`
  Called when a node is visisted, i.e., get().

  Specified by:
    `nodeVisited` in interface `TreeCacheListener`
  Overrides:
    `nodeVisited` in class `AbstractTreeCacheListener`

### cacheStarted

    public void cacheStarted(TreeCache cache)

  Description copied from interface: `TreeCacheListener`
  Called when the cache is started.

  Specified by:
    `cacheStarted` in interface `TreeCacheListener`
  Overrides:
    `cacheStarted` in class `AbstractTreeCacheListener`

### cacheStopped

    public void cacheStopped(TreeCache cache)

  Description copied from interface: `TreeCacheListener`
  Called when the cache is stopped.

  Specified by:
    `cacheStopped` in interface `TreeCacheListener`
  Overrides:
    `cacheStopped` in class `AbstractTreeCacheListener`

### viewChange

    public void viewChange(org.jgroups.View new_view)

  Specified by:
    `viewChange` in interface `TreeCacheListener`
  Overrides:
    `viewChange` in class `AbstractTreeCacheListener`

### setConfig

    public void setConfig(java.util.Properties props)

  Description copied from interface: `CacheLoader`
  Sets the configuration. This is called before `Service.create()` and `Service.start()`.

  Specified by:
    `setConfig` in interface `CacheLoader`
  Parameters:
    `props` - a collection of configuration properties

### setCache

    public void setCache(TreeCache c)

  Description copied from interface: `CacheLoader`
  Sets the `TreeCache` that is maintaining this CacheLoader. This method allows this CacheLoader to invoke methods on TreeCache, including fetching additional configuration information. This method is called be called after the CacheLoader instance has been constructed.

  Specified by:
    `setCache` in interface `CacheLoader`
  Parameters:
    `c` - The cache on which this loader works

### getChildrenNames

    public java.util.Set getChildrenNames(Fqn fqn)
                                   throws java.lang.Exception

  Description copied from interface: `CacheLoader`
  Returns a set of children node names as Strings. All names are relative to this parent `Fqn`. Returns null if the named node is not found or there are no children. The returned set must not be modifiable. Implementors can use `Collections.unmodifiableSet(Set)` to make the set unmodifiable.

  Specified by:
    `getChildrenNames` in interface `CacheLoader`
  Parameters:
    `fqn` - The FQN of the parent
  Returns:
    Set a set of children. Returns null if no children nodes are present, or the parent is not present
  Throws:
    `java.lang.Exception`

### get

    public java.util.Map get(Fqn name)
                      throws java.lang.Exception

  Description copied from interface: `CacheLoader`
  Returns all keys and values from the persistent store, given a fully qualified name. NOTE that the expected return value of this method has changed from JBossCache 1.2.x and before! This will affect cache loaders written prior to JBossCache 1.3.0 and such implementations should be checked for compliance with the behaviour expected.

  Specified by:
    `get` in interface `CacheLoader`
  Returns:
    Map keys and values for the given node. Returns null if the node is not found. If the node is found but has no attributes, this method returns an empty Map.
  Throws:
    `java.lang.Exception`

### exists

    public boolean exists(Fqn name)
                   throws java.lang.Exception

  Description copied from interface: `CacheLoader`
  Returns true if the CacheLoader has a node with a `Fqn`.

  Specified by:
    `exists` in interface `CacheLoader`
  Returns:
    true if node exists, false otherwise
  Throws:
    `java.lang.Exception`

### put

    public java.lang.Object put(Fqn name,
                                java.lang.Object key,
                                java.lang.Object value)
                         throws java.lang.Exception

  Description copied from interface: `CacheLoader`
  Puts a key and value into the attribute map of a given node. If the node does not exist, all parent nodes from the root down are created automatically. Returns the old value.

  Specified by:
    `put` in interface `CacheLoader`
  Throws:
    `java.lang.Exception`

### put

    public void put(Fqn name,
                    java.util.Map attributes)
             throws java.lang.Exception

  Description copied from interface: `CacheLoader`
  Puts all entries of the map into the existing map of the given node, overwriting existing keys, but not clearing the existing map before insertion. This is the same behavior as `Map.putAll(java.util.Map)`. If the node does not exist, all parent nodes from the root down are created automatically

  Specified by:
    `put` in interface `CacheLoader`
  Parameters:
    `name` - The fully qualified name of the node
    `attributes` - A Map of attributes. Can be null
  Throws:
    `java.lang.Exception`

### put

    public void put(java.util.List modifications)
             throws java.lang.Exception

  Description copied from interface: `CacheLoader`
  Applies all modifications to the backend store. Changes may be applied in a single operation.

  Specified by:
    `put` in interface `CacheLoader`
  Parameters:
    `modifications` - A List of modifications
  Throws:
    `java.lang.Exception`

### remove

    public java.lang.Object remove(Fqn name,
                                   java.lang.Object key)
                            throws java.lang.Exception

  Description copied from interface: `CacheLoader`
  Removes the given key and value from the attributes of the given node. Does nothing if the node doesn't exist Returns the removed value.

  Specified by:
    `remove` in interface `CacheLoader`
  Throws:
    `java.lang.Exception`

### remove

    public void remove(Fqn name)
                throws java.lang.Exception

  Description copied from interface: `CacheLoader`
  Removes the given node and all its subnodes.

  Specified by:
    `remove` in interface `CacheLoader`
  Throws:
    `java.lang.Exception`

### removeData

    public void removeData(Fqn name)
                    throws java.lang.Exception

  Description copied from interface: `CacheLoader`
  Removes all attributes from a given node, but doesn't delete the node itself or any subnodes.

  Specified by:
    `removeData` in interface `CacheLoader`
  Throws:
    `java.lang.Exception`

### prepare

    public void prepare(java.lang.Object tx,
                        java.util.List modifications,
                        boolean one_phase)
                 throws java.lang.Exception

  Description copied from interface: `CacheLoader`
  Prepares a list of modifications. For example, for a DB-based CacheLoader:
  1. Create a local (JDBC) transaction
  2. Associate the local transaction with `tx` (tx is the key)
  3. Execute the coresponding SQL statements against the DB (statements derived from modifications)
  For non-transactional CacheLoader (e.g. file-based), this could be a null operation.

  Specified by:
    `prepare` in interface `CacheLoader`
  Parameters:
    `tx` - The transaction, just used as a hashmap key
    `modifications` - List, a list of all modifications within the given transaction
    `one_phase` - Persist immediately and (for example) commit the local JDBC transaction as well. When true, we won't get a `CacheLoader.commit(Object)` or `CacheLoader.rollback(Object)` method call later
  Throws:
    `java.lang.Exception`

### commit

    public void commit(java.lang.Object tx)
                throws java.lang.Exception

  Description copied from interface: `CacheLoader`
  Commits the transaction. A DB-based CacheLoader would look up the local JDBC transaction asociated with `tx` and commit that transaction. Non-transactional CacheLoaders could simply write the data that was previously saved transiently under the given `tx` key, to (for example) a file system (note this only holds if the previous prepare() did not define one_phase=true

  Specified by:
    `commit` in interface `CacheLoader`
  Parameters:
    `tx` - transaction to commit
  Throws:
    `java.lang.Exception`

### rollback

    public void rollback(java.lang.Object tx)

  Description copied from interface: `CacheLoader`
  Rolls the transaction back. A DB-based CacheLoader would look up the local JDBC transaction asociated with `tx` and roll back that transaction.

  Specified by:
    `rollback` in interface `CacheLoader`
  Parameters:
    `tx` - transaction to roll back

### loadEntireState

    public byte[] loadEntireState()
                           throws java.lang.Exception

  Description copied from interface: `CacheLoader`
  Fetches the entire state for this cache from secondary storage (disk, DB) and returns it as a byte buffer. This is for initialization of a new cache from a remote cache. The new cache would then call `CacheLoader.storeEntireState(byte[])`.

  Specified by:
    `loadEntireState` in interface `CacheLoader`
  Throws:
    `java.lang.Exception`

### storeEntireState

    public void storeEntireState(byte[] state)
                          throws java.lang.Exception

  Description copied from interface: `CacheLoader`
  Stores the given state in secondary storage. Overwrites whatever is currently in storage.

  Specified by:
    `storeEntireState` in interface `CacheLoader`
  Throws:
    `java.lang.Exception`

### create

    public void create()
                throws java.lang.Exception

  Specified by:
    `create` in interface `org.jboss.system.Service`
  Throws:
    `java.lang.Exception`

### start

    public void start()
               throws java.lang.Exception

  Specified by:
    `start` in interface `org.jboss.system.Service`
  Throws:
    `java.lang.Exception`

### stop

    public void stop()

  Specified by:
    `stop` in interface `org.jboss.system.Service`

### destroy

    public void destroy()

  Specified by:
    `destroy` in interface `org.jboss.system.Service`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1998-2005 JBoss Inc . All Rights Reserved.